package aexp.remoteview;

import android.app.Service;
import android.os.IBinder;
import android.util.Log;
import android.os.Bundle;
import android.os.Handler;
import android.content.Intent;
import android.widget.RemoteViews;
import android.widget.ProgressBar;
import java.util.GregorianCalendar;
import java.util.Calendar;
import java.util.Formatter;

public class TimeViewService extends Service {
	private static final String LOG_TAG = "TIMEVIEWSERVICE";

    @Override
    public IBinder onBind( Intent intent ) {
        return binder;
    }

    @Override
    public void onCreate() {
      super.onCreate();
	  Log.d( LOG_TAG,"onCreate" );
    }

    @Override
    public void onDestroy() {
	  super.onDestroy();
	  Log.d( LOG_TAG,"onDestroy" );
    }

    /**
     * The ITimeViewService is defined through IDL
     */
    private final ITimeViewService.Stub binder = 
			new ITimeViewService.Stub() {
      public RemoteViews getTimeView() {
        RemoteViews timeView = 
            new RemoteViews(
                    getPackageName(), 
                    R.layout.timeview );
        GregorianCalendar c = new GregorianCalendar();
        StringBuffer b = new StringBuffer();
        Formatter f = new Formatter( b );
        f.format( "%02d:%02d:%02d",
                c.get( Calendar.HOUR_OF_DAY ),
                c.get( Calendar.MINUTE ),
                c.get( Calendar.SECOND ) );
        String timeString = new String( b );
        int progress = ( c.get( Calendar.HOUR_OF_DAY ) * 60 + c.get( Calendar.MINUTE ) ) * 100 / ( 24*60 );
        timeView.setProgressBar( R.id.time_progress, 100, progress, false );
        timeView.setTextViewText( R.id.time,timeString );
        return timeView;
      }
    };

}